<script>
export default {
  name: `cbr-card`,
  props: {
    to: { type: [String, Object], default: null },
    disabled: { type: Boolean, default: false },
    clickable: { type: Boolean, default: true },
  },
  computed: {
    classes() {
      return {
        'cbr-card': true,
        'cbr-card--disabled': this.disabled,
        'cbr-card--clickable': this.clickable,
        'cbr-card--dark': this.$vuetify.theme.dark,
      };
    },
  },
  methods: {
    onClick() {
      if (this.to === null) return;
      this.$router.push(this.to);
    }
  },
}
</script>

<template>
  <div :class="classes" @click="onClick">
    <slot></slot>
  </div>
</template>

<style lang="scss" scoped>
.cbr-card {
  --bg-color: #eeeeee;
  --bg-color--hover: #f5f5f5;
  background-color: var(--bg-color);
  border-radius: var(--border-radius);
  padding: 12px;
  box-shadow:
    0px 3px 1px -2px rgba(0, 0, 0, 0.2),
    0px 2px 2px 0px rgba(0, 0, 0, 0.14),
    0px 1px 5px 0px rgba(0, 0, 0, 0.12);
  
  &--dark {
    --bg-color: #424242;
    --bg-color--hover: #757575;
  }

  &--disabled {
    opacity: 0.6;
  }

  &--clickable {
    cursor: pointer;
  }

  &--clickable:hover {
    background-color: var(--bg-color--hover);
  }
}
</style>
